###########################################################
#
#    Copyright (C) 2008 Matt666  V1.0
#
#    This program is free software: you can gna gna gna gna... 
#   
###########################################################

require 'sketchup.rb'

module NormBlock
	def NormBlock.work
		model = Sketchup.active_model
		defs = model.definitions
		if defs
			model.start_operation "Normalize blocks"
			Sketchup::set_status_text ("Program is running..."), SB_PROMPT
			for d in defs
				NormBlock.normalize(d.entities)
			end
			Sketchup::set_status_text ("Done!"), SB_PROMPT
			Sketchup.send_action "selectSelectionTool:"
			model.active_view.invalidate
			model.commit_operation
		else
			UI.messagebox("No components in this drawing.")
		end
	end

	def NormBlock.normalize(ents)
		ents.each do |ent|
			if ent.typename == "Group"
				NormBlock.normalize(ent.entities)
			elsif ent.typename == "ComponentInstance"
				NormBlock.normalize(ent.definition.entities)
			elsif ent.respond_to? "layer"
				ent.layer=Sketchup.active_model.layers[0]
			end
		end
	end
end

if not file_loaded?("NormBlock.rb")
	UI.menu.add_item("Normalize blocks"){NormBlock.work}
end
file_loaded("NormBlock.rb")